<?php
require_once '../include/functions.php';

// Cria objeto
if (isset($_POST['table'])) {
	$tabela = ucfirst($_POST['table']);
	if (!file_exists(PATH_CLASS."/{$tabela}.class.php")) {
		echo utf8_encode("Classe <b>{$_POST['table']}</b> no encontrada.");
		exit;
	}
} else {
	echo utf8_encode("Classe no encontrada.");
	exit;
}

// Cria o objeto
$objeto = new $tabela;
$camposObrigatorios = $objeto->getFieldsRequiredFromTable();

/*
$camposObrigatorios = '';
if (isset($_POST['obrigatorios'])) {
	$campos = explode(',', $_POST['obrigatorios']);
	if (is_array($campos)) {
		foreach ($campos as $campo) {
			$camposObrigatorios[] = $campo;
		}
	}
}
*/

//pr($_POST);
// Define tipo de formulrio
$dados = '';
foreach ($_POST as $key => $value) {
	if ($value != '') {
		if (is_array($value)) {
			foreach ($value as $key2 => $value2) {
				if (in_array(substr($key2, 0, 3), array('gri', 'adv', 'ped', 'tas', 'cap', 'int', 'lar', 'alt', 'com'))) {
					$valor = '';
					$valor = str_replace('.', '', $value2);
					$valor = str_replace(',', '.', $valor);
					$dados[$key][$key2] = $valor;
				} else {
					$dados[$key][$key2] = $value2;
				}
				
			}
		} else if (in_array(substr($key, 0, 5), array('email'))) {
			$dados[$key] = trim(mb_strtolower(utf8_decode($value)));
		} else if ($key == 'CPF_CNPJ') {
			$dados[$key] = str_replace(array('.', '-', '/'), '', $value);
		} else if (substr($key, 0, 4) == 'data') {
			$dados[$key] = substr($value, 6).'-'.substr($value, 3, 2).'-'.substr($value, 0, 2);
		} else if (in_array(substr($key, 0, 3), array('gri', 'adv', 'ped', 'tas', 'cap', 'int', 'lar', 'alt', 'com', 'pre'))) {
			$valor = '';
			$valor = str_replace('.', '', $value);
			$valor = str_replace(',', '.', $valor);
			$dados[$key] = $valor;
		} else {
			$dados[$key] = trim(utf8_decode(htmlspecialchars($value)));
		}
	}
}

//pr($camposObrigatorios);
//pr($dados);exit;

// Verifica campos obrigatrios
$erro = 0;
foreach ($camposObrigatorios as $campo) {
	if( !key_exists($campo, $dados)) {
		$erro++;
	}
}
if ($erro != 0) {
	echo utf8_encode('Preencha os campos obrigatrios.');
} else {
	
	$registro = $objeto->loadByID($_POST['id']);
	foreach ($dados as $key => $valor) {
		if ($key != 'table') {
			$registro->$key = $valor;
		}
	}
	
	if ($_POST['table'] == 'cidades') {
		$seccat = str_replace(',', '.', $dados['seccat']);
		$registro->seccat = $seccat;
	}
	if ($_POST['table'] == 'grupos') {
		$obGrupos = new Grupos();
		$grupo_id = $dados['id'];
		$obGrupos->retrieveByQuery(" DELETE FROM grupos_permissoes WHERE grupo_id = {$grupo_id}");
		if (isset($dados['permissao'])) {
			foreach ($dados['permissao'] as $permissao_id => $permissoes) {
				$obGrupoPermissao = new Grupos_permissoes();
				$obGrupoPermissao->permissao_id = $permissao_id;
				$obGrupoPermissao->grupo_id = $grupo_id;
				foreach ($permissoes as $permissao => $valor) {
					$obGrupoPermissao->$permissao = ($valor == 'on') ? 1 : 0;
				}
				$obGrupoPermissao->insertDB(false);
			}
		}
	}
	if ($_POST['table'] == 'tabelas') {
		$tabela_id = $dados['id'];
		$obEstados = new Estados();
		$obClientes = new Clientes();
		if ($tabela_id != 1) {
			$cnpj = $dados['cnpj'];
			$cliente = $obClientes->retrieveAll(" cnpj = '{$cnpj}' ");
			if (!$cliente) {
				echo utf8_encode('Este CNPJ no est cadastrado.');
				exit;
			}
			$registro->cliente_id = $cliente[0]->id;
		}
		$estados = $obEstados->retrieveAll();
		foreach ($estados as $estado):
			$tabelaItens = new Itens();
			$tabelaItens->retrieveByQuery("DELETE FROM itens WHERE tabela_id = {$tabela_id} AND estado_sigla = '{$estado->sigla}'");
			$tabelaItens->tabela_id = $tabela_id;
			$tabelaItens->estado_sigla = $estado->sigla;
			foreach ($dados[$estado->sigla] as $indice => $valor):
				$tabelaItens->$indice = $valor;
			endforeach;
			$tabelaItens->insertDB(false);
		endforeach;
	}
	
	if ($registro->updateDB(false)) {
		echo 'ok';
		echo PATH_WWW_ADMIN.'/'.strtolower($_POST['pagina']); // REDIRECT
	} else {
		echo utf8_encode('Erro ao atualizar registro.');
	}
	
}
