<?php
/*
.---------------------------------------------------------------------------.
|  Software: ineoDAO 														|
|   Version: 2.2.0 2012-06-27                                               |
|   Contact: 																|
|      Info: Classe para abstrao de dados MySQL							|
|   Support: 																|
| ------------------------------------------------------------------------- |
|     Admin: Rafael Xavier (project admininistrator)                   |
|   Authors: Rafael Xavier (codeworxtech)	|
|   Founder:                            									|
| Copyright (c) 2004-2012, Sistemas Ltda. All Rights Reserved.         |
'---------------------------------------------------------------------------'

 27/06/2012 - Novo Mtodo: getCamposObrigatorios();

*/

class DAO {
	
	protected $table;
	protected $class;
	protected $environment;
	protected $basedir = '';
	protected $conn;
	
	private $objeto;
	
	/**
	 * Constructor
	 *
	 * @param string $table
	 */
	function __construct($table) {
		$this->table = strtolower($table);
		$this->class = ucfirst($table);
		self::connect(__FUNCTION__);
	}
	
	function __set($name, $value) {
		$this->objeto->$name = $value;
	}
	
	function __get($name) {
		return $this->objeto->$name;
	}
		
	function connect($function) {
		$host = '';
		$user = '';
		$password = '';
		$database = '';
		if ($_SERVER['SERVER_ADDR'] == '127.0.0.1') { // LOCAL SERVER
			
			$host = 'localhost';
			$user = 'root';
			$password = '';
			$database = 'yuupiii_db';
			$this->environment = 'development';
			$this->basedir = '';
			
		} else { 
			
			$host = 'localhost';
			$user = 'produtomaniacom_root';
			$password = 'S$].,Bug8_iO';
			$database = 'produtomaniacom_drop';
			$this->environment = 'production';
			//$this->environment = 'development';
			
		}
		
		if ($this->conn == false) {
			$conn = @mysql_connect($host, $user, $password);
			if ($conn) {
				//echo "==> CONECTOU: {$function}\n";
				$this->conn = $conn;
				@mysql_select_db($database, $conn);
			} else {
				self::printError('No foi possvel conectar ao banco de dados.');
				exit();
			}
		} else {
			if (!mysql_ping($this->conn)) {
				$conn = @mysql_connect($host, $user, $password);
				if ($conn) {
					//echo "==> CONECTOU: {$function}\n";
					$this->conn = $conn;
					@mysql_select_db($database, $conn);
				} else {
					self::printError('No foi possvel conectar ao banco de dados.');
					exit();
				}
			}
		}
	}
	
	
	function insertDB($debug = false) {
		self::connect(__FUNCTION__);
		$campos = self::getTypesFromFields();
		$query = "INSERT INTO {$this->table} SET ";
		foreach ($this->objeto as $key => $value) {
			if ($campos[$key] == 'int') {
				if ($value == '') $value = 'null';
				$query .= "{$this->table}.{$key} = {$value}, ";
			} else {
				$query .= "{$this->table}.{$key} = '".addslashes($value)."', ";
			}
		}

		
		$query = substr($query, 0, -2);
		
		// DEBUG
		if ($debug) { 
			self::printDebug($query); 
			//exit;
		}
		
		$result = mysql_query($query); 
		if ($result) {
			//mysql_close($this->conn);
			return true;
		} else {
			//mysql_close($this->conn);
			return false;
		}
		
		// Libera a memria
		@mysql_free_result($result);
		
	}
	
	
	/**
	 * UPDATE
	 * Update table
	 */
	function updateDB($debug = false, $where = null){
		self::connect(__FUNCTION__);
		$campos = self::getTypesFromFields();
		$key = self::getKey();
		$query = "UPDATE ".$this->table." SET "; 
		foreach ($campos as $chave => $value) {
			if ($chave != $key) {
				if ($value == 'int') {
					if (empty($this->objeto->$chave)) $this->objeto->$chave = 'null';
					$query .= $this->table . '.' . $chave . ' = ' . $this->objeto->$chave . ', ';
				} else {
					$query .= $this->table . '.' . $chave . ' = "' . addslashes($this->objeto->$chave) . '", ';
				}
			}
		}
		$query = substr($query, 0, -2);
		if (!is_null($where)) {
			$query .= " WHERE {$where}";		
		} else {
			$query .= ' WHERE '. $key . ' = ' . $this->objeto->$key;
		}
		
		// DEBUG
		if ($debug) { 
			self::printDebug($query); 
			//exit;
		}
		
		$result = @mysql_query($query); 
		if ($result) {
			//mysql_close($this->conn);
			return true;
		} else {
			//mysql_close($this->conn);
			return false;
		}
		
		// Libera a memria
		@mysql_free_result($result);
	}
	
	
	/**
	 * DEL
	 * Method for remove of table
	 */
	function delDB($debug = false){
		self::connect(__FUNCTION__);
		$key = self::getKey();
		$query = "DELETE FROM {$this->table} WHERE {$key} = ".$this->objeto->$key;
		
		// DEBUG
		if ($debug) { 
			self::printDebug($query); 
		}
		
		$result = @mysql_query($query); 
		if ($result) {
			//mysql_close($this->conn);
			return true;
		} else {
			//mysql_close($this->conn);
			return false;
		}
		
		// Libera a memria
		@mysql_free_result($result);
	}
	
	
	/**
	 * 
	 * Retrieve all results from table
	 * @param string $param
	 * @param string $order
	 * @param string $limit
	 * @param bool $debug
	 */
	function retrieveAll($param = '', $order = '', $limit = '', $debug = false) {
		self::connect(__FUNCTION__);
		
		$query = "SELECT * FROM {$this->table} ";
		if (!empty($param)) {
			$query .= " WHERE ".$param;
		}
		if (!empty($order)) {
			$query .= " ORDER BY ".$order;
		}
		if (!empty($limit)) {
			$query .= " LIMIT ".$limit;
		}
		
		// DEBUG
		if ($debug) { 
			self::printDebug($query); 
		}
		
		$rs = self::validQuery($query);
		
		$result = self::validQuery($query);
		$countFields = @mysql_num_rows($result);
		$obResult = new ArrayObject();
		
		if ($countFields > 0) {
			while ($r = mysql_fetch_object($result)) {
				$obResult->append($r);
			}
			//mysql_close($this->conn);
			return $obResult;
		} else {
			//mysql_close($this->conn);
			return false;
		}		
		// Libera a memria
		@mysql_free_result($result);
	}
	
	
	/**
	 * RETRIEVE BY QUERY
	 */
	function retrieveByQuery($query, $debug = false) {
		//self::connect(__FUNCTION__);
		
		// DEBUG
		if ($debug) { 
			self::printDebug($query); 
		}
		//echo $query."<br>";
		$result = self::validQuery($query);
		if ($result) {
			$countFields = @mysql_num_rows($result);
			if ($countFields > 0) {
				$obResult = new ArrayObject();
				while ($r = mysql_fetch_object($result)) {
					$obResult->append($r);
				}
				//mysql_close($this->conn);
				return $obResult;
			} else {
				//mysql_close($this->conn);
				return false;
			}		
			// Libera a memria
			@mysql_free_result($result);
		} else {
			//mysql_close($this->conn);
			return false;
		}
	}
	
	
	/**
	 * 
	 * Load data to object
	 * @param int $id
	 * @param bool $debug
	 */
	function loadByID($id, $debug = false) {
		self::connect(__FUNCTION__);
		$query = 'SELECT * FROM ' . $this->table . ' WHERE ' . self::getKey() . ' = ' . "'{$id}'";
		// DEBUG
		if ($debug) { 
			self::printDebug($query); 
		}
		$result = self::validQuery($query);
		$countFields = @mysql_num_rows($result);
		$obResult = mysql_fetch_object($result);
		//pr($obResult);
		$object = new $this->class;
		if ($countFields > 0) {
			foreach ($obResult as $key => $value) {
				$this->objeto->$key = $value;
			}
			$class = self::convertClass($this->objeto, $this->class);
			return $class;
		} else {
			//self::printError(__FUNCTION__.': objeto vazio.');
			return false;
		}
			
		// Libera a memria
		@mysql_free_result($result);
	}
	
	function convertClass(stdClass $class, $newClass) {
		$object = new $newClass;
		foreach($class as $key => $value) {
			$object->__set($key, $value);
		}
		return $object;
	}
	
	/**
	 * 
	 * Valid query
	 * @param unknown_type $query
	 */
	function validQuery($query) {
		self::connect(__FUNCTION__);
		$result = @mysql_query($query);
		if ($result) {
			return $result;
		} else {
			echo self::printError($query . ' <br /><b>' . mysql_error() . '</b>');
			exit();
		}
	}
	
	/**
	 * 
	 * Get a KEY from table
	 * @return string
	 * 
	 * (
	 *    [Field] => id
	 * 	  [Type] => int(11)
	 * 	  [Null] => NO
	 * 	  [Key] => PRI
	 * 	  [Default] =>
	 * 	  [Extra] => auto_increment
	 * )
	 * 
	 */
	function getKey() {
		self::connect(__FUNCTION__);
		$query = "SHOW KEYS FROM {$this->table}";
		$rs = mysql_query($query);
		while ($r = mysql_fetch_array($rs)) {
			if ($r['Key_name'] == 'PRIMARY') {
				return $r['Column_name'];
			}
		}
	}
	
	function getCountRecords($query) {
		self::connect(__FUNCTION__);
		$qty = @mysql_num_rows(mysql_query($query));
		if ($qty > 0) {
			return $qty;
		} else {
			return 0;
		}
	}
	
	function getVarsFromTable() {
		self::connect(__FUNCTION__);
		$query = "SHOW FIELDS FROM {$this->table}";
		$rs = mysql_query($query);
		$obj = new ArrayObject();
		while ($r = mysql_fetch_array($rs)) {
			$obj->append($r['Field']);
		}
		return $obj->getArrayCopy();
	}
	
	function getFieldsRequiredFromTable() {
		self::connect(__FUNCTION__);
		$query = "SHOW FIELDS FROM {$this->table}";
		$rs = mysql_query($query);
		$obj = new ArrayObject();
		while ($r = mysql_fetch_array($rs)) {
			if ($r['Key'] == '' AND $r['Null'] == 'NO') {
				$obj->append($r['Field']);
			}
		}
		return $obj->getArrayCopy();
	}
	
	function getTypesFromFields() {
		self::connect(__FUNCTION__);
		$describe = "DESCRIBE {$this->table}";
		$rs = mysql_query($describe);
		$array = null;
		while ($r = @mysql_fetch_object($rs)) {
			$array[$r->Field] = substr($r->Type, 0, strpos($r->Type, '('));
		}
		return $array;
	}
	
	function getBasedir() {
		return $_SERVER['DOCUMENT_ROOT'] . '/' . $this->basedir;
	}
	
	function getConnection() {
		return $this->conn;
	}
	
	function pr($array) {
		echo '<pre>';
		print_r($array);
		echo '</pre>';
	}
	
	/**
	 * 
	 * Enter description here ...
	 * @param string $query
	 */
	function printDebug($query) {
	?>
		<div style="border: 1px solid #629DE3; background: #D8E5F8; color: #3155D0; font-size: 10px; font-family: Verdana, Arial; margin: 10px; padding: 10px;"><?php echo $query; ?></div>
	<?php
	}
	
	function printError($query) {
		if ($this->environment == 'development') {
	?>
		<div style="border: 1px solid #FE7B7A; background: #FFD6D6; color: #DD0000; font-size: 10px; font-family: Verdana, Arial; margin: 10px; padding: 10px;"><?php echo $query; ?></div>
	<?php
		} else {
	?>
		<div style="border: 1px solid #C2DF88; background: #EEF7DD; color: #57861A; font-size: 10px; font-family: Verdana, Arial; margin: 10px; padding: 10px;">O sistema est temporariamente indisponvel. Por favor tente mais tarde.</div>
	<?php
		}
	}
	
} // End of class
ini_set('error_reporting', E_STRICT);
?>