<?php

	class Util
	{
		
		function converteData($data) {
			$data_nova = implode(preg_match("~\/~", $data) == 0 ? "/" : "-", array_reverse(explode(preg_match("~\/~", $data) == 0 ? "-" : "/", $data)));
			return $data_nova;
		}
		
		function converteDataHora($datahora, $horario = true) {
			$data = explode(" ", $datahora);
			$data_nova = implode(preg_match("~\/~", $data[0]) == 0 ? "/" : "-", array_reverse(explode(preg_match("~\/~", $data[0]) == 0 ? "-" : "/", $data[0])));
			if ($horario)
				return $data_nova.' '.$data[1];
			else
				return $data_nova;
		}
		
		function getMes($mes) {
			$meses = array(
				1 => 'Janeiro', '01' => 'Janeiro',
				2 => 'Fevereiro', '02' => 'Fevereiro',
				3 => 'Maro', '03' => 'Maro',
				4 => 'Abril', '04' => 'Abril',
				5 => 'Maio', '05' => 'Maio',
				6 => 'Junho', '06' => 'Junho',
				7 => 'Julho', '07' => 'Julho',
				8 => 'Agosto', '08' => 'Agosto',
				9 => 'Setembro', '09' => 'Setembro',
				10 => 'Outubro', '10' => 'Outubro',
				11 => 'Novembro', '11' => 'Novembro',
				12 => 'Dezembro', '12' => 'Dezembro'
			);
			return $meses[$mes];
		}
		
		function money($var) {
			return "R$ ".number_format($var, 2, ",", ".");			
		}
		
		function CPF_CNPJ($campo, $formatado = true){
			//retira formato
			$codigoLimpo = preg_replace("[' '-./ t]",'',$campo);
			// pega o tamanho da string menos os digitos verificadores
			$tamanho = (strlen($codigoLimpo) -2);
			//verifica se o tamanho do cdigo informado  vlido
			if ($tamanho != 9 && $tamanho != 12){
				return false;
			}
			if ($formatado){
				// seleciona a mscara para cpf ou cnpj
				$mascara = ($tamanho == 9) ? '###.###.###-##' : '##.###.###/####-##';
				$indice = -1;
				for ($i=0; $i < strlen($mascara); $i++) {
					if ($mascara[$i]=='#') $mascara[$i] = $codigoLimpo[++$indice];
				}
				//retorna o campo formatado
				$retorno = $mascara;
			}else{
				//se no quer formatado, retorna o campo limpo
				$retorno = $codigoLimpo;
			}
			return $retorno;
		}
		
		function createDir($path_dir, $mode = 0775) {
			if (!file_exists($path_dir)) {
				if (mkdir($path_dir, $mode, true)) {
					return true;
				} else {
					return false;
				}
			}
		}
		
		function retira_acentos( $texto ) {
			$array1 = array(   "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "" );
			$array2 = array(   "a", "a", "a", "a", "a", "e", "e", "e", "e", "i", "i", "i", "i", "o", "o", "o", "o", "o", "u", "u", "u", "u", "c", "A", "A", "A", "A", "A", "E", "E", "E", "E", "I", "I", "I", "I", "O", "O", "O", "O", "O", "U", "U", "U", "U", "C" );
			return str_replace( $array1, $array2, $texto );
		}
		
		function rename($nome) {
			$name = self::retira_acentos($nome);
			$chars = array('\'', ':', '!', ',', '&', '#', '.', '\'', '');			
			$name = str_replace($chars, "", $name);
			$name = str_replace(array(' ', '/'), "_", $name);
			return $name;
		}
		
		/**
		 * Create image temp
		 *
		 * @param array $file
		 * @param String $target
		 * @param int $width
		 * @return boolean (true/false)
		 *
		 * ex: createImageTemp($_FILES['id_name'], '/image/', 'home.jpg', 150);
		 *
		 */
		function createImage($file, $target, $name, $width, $quality=85, $crop=false, $crop_ratio=1) {
			
			/*
			//$extension = substr($file['name'], 0 -3);exit;
			//$extension = (strtolower($extension) == 'jpg') ? 'jpeg' : strtolower($extension);
			$image_function = "imagecreatefromjpeg";
			if (($pic_im = $image_function($file)) !== false) {
				# Create the image
				self::resize($pic_im, $target.$name, $width, $quality, $crop, $crop_ratio);
				return true;
			} else {
				return false;
			}
			imagedestroy($pic_im);
			*/
			//pr($file);exit;
			$extension = substr($file, -3);
			//pr($extension);
			$extension = (strtolower($extension) == 'jpg') ? 'jpeg' : strtolower($extension);
			$image_function = "imagecreatefrom{$extension}";
			if (($pic_im = $image_function($file)) !== false) {
				// Redimensiona
				self::resize($pic_im, $target.$name, $width, $quality, $crop, $crop_ratio);
				return true;
			} else {
				return false;
			}
			imagedestroy($pic_im);
		}
		
		/**
		 * resize
		 *
		 * @param unknown_type $src_im
		 * @param unknown_type $dpath
		 * @param unknown_type $maxd
		 * @param unknown_type $quality
		 * @param unknown_type $crop
		 * @param unknown_type $crop_ratio
		 */
		function resize(&$src_im, $dpath, $maxd, $quality=85, $crop=false, $crop_ratio=1) {
			$src_width = imagesx($src_im);
			$src_height = imagesy($src_im);
			$src_ratio = $src_width / $src_height;
			$src_w = $src_width;
			$src_h = $src_height;
			$src_x = 0;
			$src_y = 0;
		
			if ($crop) {
				if ($src_ratio > $crop_ratio) {
					$src_h = $src_height;
					$src_w = round($src_h * $crop_ratio);
					if ($src_h > $src_w) {
						$dst_h = ($src_h > $maxd) ? $maxd : $src_h;
						$dst_w = round($dst_h * $crop_ratio);
					} else {
						$dst_w = ($src_w > $maxd) ? $maxd : $src_w;
						$dst_h = round($dst_w / $crop_ratio);
					}
					$src_x = round(($src_width - $src_w) / 2);
				} else {
					$src_w = $src_width;
					$src_h = round($src_w / $crop_ratio);
					if ($src_w > $src_h) {
						$dst_w = ($src_w > $maxd) ? $maxd : $src_w;
						$dst_h = round($dst_w / $crop_ratio);
					} else {
						$dst_h = ($src_h > $maxd) ? $maxd : $src_h;
						$dst_w = round($dst_h * $crop_ratio);
					}
					$src_y = round(($src_height - $src_h) / 2);
				}
			} else {
				if ($src_width > $maxd || $src_height > $maxd) {
					if ($src_width > $src_height) {
						$dst_w = $maxd;
						$dst_h = floor($src_height * ($maxd / $src_width));
					} else {
						$dst_h = $maxd;
						$dst_w = floor($src_width * ($maxd / $src_height));
					}
				} else {
					$dst_w = $src_width;
					$dst_h = $src_height;
				}
			}
		
			$isTrueColor = imageistruecolor($src_im);
			if ( $isTrueColor) {
				$thumb  = imagecreatetruecolor( $dst_w, $dst_h );
				imagealphablending($thumb, false);
				imagesavealpha  ( $thumb  , true );
				imagecopyresampled($thumb, $src_im, 0, 0, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h);
				//imagejpeg($thumb, $dpath, $quality);
				imagepng($thumb, $dpath);
			} else {
				$thumb  = imagecreate( $dst_w, $dst_h );
				imagealphablending( $thumb, false );
				$transparent = imagecolorallocatealpha( $thumb, 0, 0, 0, 127 );
				imagefill( $thumb, 0, 0, $transparent );
				imagesavealpha( $thumb,true );
				imagealphablending( $thumb, true );
				imagecopyresampled($thumb, $src_im, 0, 0, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h);
				imagejpeg($thumb, $dpath, $quality);
			}
			
			/*
			$dst_im = imagecreatetruecolor($dst_w, $dst_h);
			$white = imagecolorallocate($dst_im, 255, 255, 255);
			imagefill($dst_im,0,0,$white);
			imagecopyresampled($dst_im, $src_im, 0, 0, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h);
			imagejpeg($dst_im, $dpath, $quality);
			imagedestroy($dst_im);
			*/
		}
		
		function recursive_remove_directory($directory, $empty=FALSE)
		{
			// if the path has a slash at the end we remove it here
			if(substr($directory,-1) == '/')
			{
				$directory = substr($directory,0,-1);
			}
		
			// if the path is not valid or is not a directory ...
			if(!file_exists($directory) || !is_dir($directory))
			{
				// ... we return false and exit the function
				return FALSE;
		
				// ... if the path is not readable
			}elseif(!is_readable($directory))
			{
				// ... we return false and exit the function
				return FALSE;
		
				// ... else if the path is readable
			}else{
		
				// we open the directory
				$handle = opendir($directory);
		
				// and scan through the items inside
				while (FALSE !== ($item = readdir($handle)))
				{
					// if the filepointer is not the current directory
					// or the parent directory
					if($item != '.' && $item != '..')
					{
						// we build the new path to delete
						$path = $directory.'/'.$item;
		
						// if the new path is a directory
						if(is_dir($path))
						{
							// we call this function with the new path
							self::recursive_remove_directory($path);
		
							// if the new path is a file
						}else{
							// we remove the file
							unlink($path);
						}
					}
				}
				// close the directory
				closedir($handle);
		
				// if the option to empty is not set to true
				if($empty == FALSE)
				{
					// try to delete the now empty directory
					if(!rmdir($directory))
					{
						// return false if not possible
						return FALSE;
					}
				}
				// return success
				return TRUE;
			}
		}
		
		function pr($var) {
			echo '<pre>';
			print_r($var);
			echo '</pre>';
		}
		
		function enviaEmail($FROM_NAME, $FROM_EMAIL, $TO_NAME, $TO_EMAIL, $SUBJECT, $MESSAGE, $IS_HTML = true, $CCOPY = true, $CONFIRM = false, $SENDGRID = true) {
			require_once ('class.phpmailer.php');
			$mail = new PHPMailer();
			$mail->IsSMTP();
			$mail->SMTPAuth = true;
			$mail->Port = 465;
			$mail->Host = '';
			$mail->Username = '';
			$mail->Password = '';
		
			if ($SENDGRID) {
				$mail->Port = 587;
				$mail->Host = 'smtp.sendgrid.net';
				$mail->Username = 'registro_2@ineosistemas.com.br';
				$mail->Password = '6dLV3g13jd';
			}
		
			$emailCopiado = 'jef@ineosistemas.com.br';
			
			// Aqui algumas informaes que sero enviadas no cabealho do email
			$mail->From = $FROM_EMAIL; // Email de quem envia o email
			$mail->FromName = $FROM_NAME; // Nome de quem envia o email
			$mail->AddAddress($TO_EMAIL, $TO_NAME); // Endereo e nome de quem vai receber o email, o nome  opcional
			if ($CCOPY === true) {
				$mail->AddBCC($emailCopiado, 'Webmaster | Artfera');
			}
			$mail->AddReplyTo('pedidos@artfera.com.br', 'Pedidos | Artfera'); // Email e nome que ser utilizado quando a pessoa responder este email
		
			if ($CONFIRM === true) {
				$mail->ConfirmReadingTo = $emailCopiado;
			}
		
			$mail->WordWrap = 100; // quebra linha sempre que uma linha atingir 50 caracteres
			$mail->IsHTML($IS_HTML); // ajusto envio do email no formato HTML
		
			$mail->Subject = $SUBJECT; // Aqui colocar o assunto do email
			$mail->Body = $MESSAGE;
			//$mail->AltBody = $mensagem;
		
			if(!$mail->Send()) {
				//echo "Mensagem n&atilde;o pode ser enviada. <p>";
				//return  "Erro: " . $mail->ErrorInfo;
				return false;
				//exit;
			} else {
				return true;
			}
		
		}
	
	}
?>