var replaceChar = function(entry) {
    out = ",";
    add = ".";
    temp = "" + entry;
    while (temp.indexOf(out)>-1) {
        pos= temp.indexOf(out);
        temp = "" + (temp.substring(0, pos) + add +
        temp.substring((pos + out.length), temp.length));
    }
    return temp;
};

var formatar_decimal_br = function(valor) {
    if (valor == 0) {
        return '0,00';
    }

    if (!valor) {
        return valor;
    }

    var valor = valor.toFixed(2);
    var valor_e_decimal = valor.split('.');
    var inteiro = valor_e_decimal[0];
    var decimal = valor_e_decimal[1];

    var vezes = inteiro.length / 3;
    var inicio = inteiro.length % 3;

    var novo_inteiro = [];
    var primeiro_ok = false;
    var contador = 0;

    $.each(inteiro.toString().split(''), function(i) {
        if (inicio === 0 && contador === 0) {
            primeiro_ok = true;
        }
        if (contador == inicio && primeiro_ok === false) {
            novo_inteiro.push('.');
            contador = 0;
            primeiro_ok = true;
        }
        if (contador !== 0 && contador % 3 === 0) {
            novo_inteiro.push('.');
        }
        novo_inteiro.push(inteiro[i]);
        contador++;
    });
    return novo_inteiro.join('') + ',' + decimal;
};

var formatar_decimal = function(valor) {
    /*
     * Transforma um decimal BR em float.
     * >>> formatar_decimal('15,00')
     * 15.00
     * >>> formatar_decimal('1.125,35')
     * 1125.35
     */

    // Retira qualquer ponto de milhar.
    valor = valor.replace('.', '');
    valor = valor.replace(',', '.');
    return parseFloat(valor);
};

jQuery.displayAlert = function(options) {
    var html;
    var options;
    if (options.closeOthers == true) {
        $('a[data-dismiss=alert]').click();
    }
    if (options.where == "modal") {
        html  = '<div class="alert alert-' + options.type + '">';
        html += '<a class="close" data-dismiss="alert">x</a>';
        html += options.message;
        html += '</div>';
        $('#modal-window .modal-body').prepend(html);
    } else {
        $('#modal-alert').modal();
        $('#modal-alert').addClass(options.type);
        $('#modal-alert').attr("rel",options.type);
        $('#modal-alert .modal-body').html(options.message);
    }
};

jQuery.loader = function(title) {
    $('html, body').animate({ scrollTop:0 }, 'fast');
    $('#loading').hide();
    if (title) {
        $('#loading .loading-text').html(title);
    }
    $('.modal-backdrop').remove();
    $('body').append('<div class="modal-backdrop in"></div>');
    $('#loading').show();
};

jQuery.remove_loader = function() {
    $('#loading').hide();
    $('.modal-backdrop').remove();
    if (title) {
        $('#loading .text').html('Carregando...');
    }
};

$(document).ready(function() {
    /* Desabilitar botao direito em todas as imagens */
    $('img').hover(function() {
        $(this).attr('oncontextmenu', 'return false');
    });

    $('.slideshow ul li img').load(function() {
        $(this).css({
            'margin-left': ($(this).width() / 2) * -1,
            position: 'relative',
            left: '50%'
        });
    });
    // $('.slideshow ul li img:first').load(function() {
    //     $('.slideshow ul li img:first').parents().filter('.moodular_wrapper')
    //         .css({'height': $('.slideshow ul li img:first').height()});
    // });

    ultimo_cep = '';

    // Busca de endereco atraves do cep.
    $('#id_cep').keyup(function(){
        var internacional = 0;
        var cep = $(this).val();
        var new_cep = '';

        for (var i = 0; i < cep.length; ++i) {
            var new_key = cep.charAt(i);
            if (((new_key < "0") || (new_key > "9")) && new_key !== "") {
                check = false;
            } else {
                new_cep = new_cep + new_key;
            }
        }

        // Verifica se cliente selecionou Internacional.
        $('#id_tipo option:selected').each(function() {
            if ($(this).val() == 'IN') {
                internacional = 1;
            }
        });

        if (new_cep.length == 8 && ultimo_cep != new_cep && !internacional) {
            ultimo_cep = new_cep;
            params = {
                'data': {
                    'zip': $(this).val(),
                    'page': 'misc/dynamic',
                    'content': 'getAddressByZip',
                    'return': 'json'
                },
                'dataType': 'json',
                'type': 'get',
                'success': function(data) {
                    if (data.address_type && data.address) {
                        address = data.address.split(/,\s+/g).reverse().join(' ');
                        $('#id_endereco').val(data.address_type + " " + address);
                        $('#id_numero').focus();
                    } else {
                        $('#id_endereco').focus();
                    }
                    if (data.district) {
                        $('#id_bairro').val(data.district);
                    }
                    if (data.city) {
                        $('#id_cidade').val(data.city);
                    }
                    if (data.state) {
                        $('#id_estado option[value="' + data.state + '"]').attr('selected','selected');
                    }
                    $('#id_pais_id option[value="BRA"]').attr('selected','selected');
                },
                'error': function() {
                    $('#id_endereco').focus();
                }
            };

            $.ajax("http://www.lojaeshop.com.br/index", params);
        }
    });

    $('#form_cadastro_completo').submit(function(){
        // Validacao pessoa fisica
        if ($('#id_tipo option:selected').val() == 'PF') {
            if($('#id_cpf').val().length < 14){
                $('#id_cpf').parent().parent().addClass('error');
                $('#id_cpf').parent().append('<span class="help-inline">Preencha o campo cpf corretamente.</span>');
                $('#id_cpf').focus();
                return false;
            }
            if( $('#id_rg').val().length < 6 ){
                $('#id_rg').parent().parent().addClass('error');
                $('#id_rg').parent().append('<span class="help-inline">Preencha o campo rg corretamente.</span>');
                $('#id_rg').focus();
                return false;
            }
        }

        // Validacao pessoa juridica
        if ($('#id_tipo option:selected').val() == 'PJ') {
            if( $('#id_cnpj').val().length < 18 ){
                $('#id_cnpj').parent().parent().addClass('error');
                $('#id_cnpj').parent().append('<span class="help-inline">Preencha o campo CNPJ corretamente.</span>');
                $('#id_cnpj').focus();
                return false;
            }
            if( $('#id_razao_social').val().length  < 5 ){
                $('#id_razao_social').parent().parent().addClass('error');
                $('#id_razao_social').parent().append('<span class="help-inline">Preencha o campo Razão Social corretamente.</span>');
                $('#id_razao_social').focus();
                return false;
            }
        }
    });

    /* MASCARAS */
    $('#id_cpf').mask('999.999.999-99');
    $('#id_cep, .input-cep').mask('99999-999');
    $('#id_cnpj').mask('99.999.999/9999-99');
    $('#id_telefone_principal').mask('(99) 9999-9999?9');
    $('#id_telefone_comercial').mask('(99) 9999-9999?9');
    $('#id_telefone_celular').mask('(99) 9999-9999?9');
    $('#id_data_nascimento').mask('99/99/9999');

    $('#id_telefone_celular, #id_telefone_comercial, #id_telefone_principal').keyup(function() {
        var tmp = $(this).val();
        tmp = tmp.replace(/[^0-9]/g,'');
        var ddd = tmp.slice(0, 2);
        var primeiro_numero = tmp[2];
        if (tmp.length == 11) {
            $(this).unmask();
            $(this).val(tmp);
            $(this).mask("(99) 99999-999?9");
        } else if (tmp.length == 11) {
            $(this).unmask();
            $(this).val(tmp);
            $(this).mask("(99) 9999-9999?9");
        } else if (tmp.length == 11) {
            $(this).unmask();
            $(this).val(tmp);
            $(this).mask("(99) 9999-9999");
        }
    });
    $('#newsletter_assinar').click(function(event) {
        event.preventDefault();
        var email = $('#email_assinar').val();
        var url = $(this).attr('href');
        if (!email) {
            alert('Por favor informe um email.');
        }else {
            $.post(url, {email: email}, function(data) {
                //alert(data);
                $('.newsletter .cadastro').addClass('hide');
                $('.newsletter .confirmacao').removeClass('hide');
            });
        }
        $('#email_assinar').val('');
    });
    // campos_com_mascara = ['id_cpf', 'id_cep', 'id_cnpj', 'id_telefone_principal', 'id_telefone_comercial', 'id_telefone_celular', 'id_data_nascimento'];
    // $('form').submit(function() {
    //     $(this).find('input[type=text]').each(function(i, e) {
    //         if ($.inArray($(e).attr('id'), campos_com_mascara) > -1) {
    //             $(e).unmask();
    //             $(e).val($(e).val().replace(/[^\d+]/g, ''));
    //         }
    //     });
    //     return true;
    // });

    // Corrigir background-position no firefox e opera
    $.each(jQuery.browser, function(i) {
        if($.browser.mozilla || $.browser.opera){
            $(".icon-white").each(function() {
                currBG = $(this).css('background-position');
                currBG = currBG.substr(0,currBG.indexOf(' ')) + ' -30px';
                $(this).css({'background-position': currBG});
            });
        }
    });

/* Barra Topo */
    var $win = $(window)
    , $nav = $('#barra-topo')
    , navTop = $('#DelimiterBar').length && $('#DelimiterBar').offset().top
    processScroll();
    $win.on('scroll', processScroll);
    function processScroll() {
        var i, scrollTop = $win.scrollTop()
        if (scrollTop > (navTop + $('#DelimiterBar').height() )) {
            $nav.fadeIn('fast');
        } else if (scrollTop < navTop) {
            $nav.fadeOut();
        }
    }

});
